var nvsSecurity = (function() {
	
	var self = {};
	var userId = null;
	var userData = {};
	
	self.getItemsFromStorage = function (key) {
		return JSON.parse(localStorage.getItem(key)) ? JSON.parse(localStorage.getItem(key)) : false;
	};
	
	self.setItemsToStorage = function (key, data) {
		localStorage.setItem(key, JSON.stringify(data));
	};

	function getCookie(cname) {
		var name = cname + "=";
		var decodedCookie = decodeURIComponent(document.cookie);
		var ca = decodedCookie.split(';');
		for(var i = 0; i <ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0) == ' ') {
				c = c.substring(1);
			}
			if (c.indexOf(name) == 0) {
				return c.substring(name.length, c.length);
			}
		}
		return "";
	}

	function isUserOwner(){
		var userHash = (userData === null || userData[dosData.dosId]===undefined) ? null : userData[dosData.dosId];
		return userHash == sh(userId + dosData.dosId, true);
	}

	function runPromo1() {

		$( document ).ready(function() {

			if($('body.page-template-module').length > 0)
			{
				var allNoFirst = $('.mu-item:not(:first)');
				allNoFirst.on('click', function(e){ e.preventDefault(); });
				allNoFirst.find('a').attr('href','');
				allNoFirst.removeClass('mu-item--online').addClass('mu-item--offline').attr('data-id','unit-0');
			}

			if(
				$('body.page-template-unit').length > 0 
			)
			{
				if($('body.page-template-unit').attr('data-pos') == 0)
				{
					// prvi page
					$(document).ready(function(){
						$("body").removeClass('js-promo-book');
					});
				}
				else
				{
					// nije prvi page
					$('.site-wrapper').html('');
					$('body').addClass('js-promo-book--forbidden'); // show user message to enter voucher
					//location.href = dosData.dosPageId + '.html';
					//location.href = 'https://moj.izzi.hr/voucher';
				}
			}

		});

	}

	function bindEvents() {

	}
	
	function construct() {
		
		// copy from cookie
		if(getCookie('user_id'))
		{
			localStorage.setItem('nvsUserId', getCookie('user_id'));  
		}

		// copy from cookie
		if(getCookie('user_data'))
		{
			localStorage.setItem('nvsUserData', getCookie('user_data'));  
		}

		userId = localStorage.getItem('nvsUserId');

		var userDataStr = localStorage.getItem('nvsUserData');
		userData = JSON.parse(userDataStr);

		if(window.location.href.indexOf("/preview/page/") > -1) 
		{
			console.log('user in preview mode');
			$(document).ready(function(){
				$("body").removeClass('js-promo-book');
			});
		}
		else
		{
			if(isUserOwner())
			{
				console.log('user is owner');

				$(document).ready(function(){
					$("body").removeClass('js-promo-book');
				});
			}
			else
			{
				if(dosData.dosExtraParam.promo !== undefined)
				{
					if(dosData.dosExtraParam.promo == "1")
					{
						console.log('user is not owner, can use Promo1');
						runPromo1();
					}
				}
				else
				{
					console.log('user not owner');
					//$('.site-wrapper').html('');
					$('body').addClass('js-promo-book--forbidden'); // show user message to enter voucher
				}
			}
		}


		//bindEvents();
	}
	
	return {
		init: function() {
			construct();
			
			return self;
		}
	};
});

var nvsCaptionNumberer = (function() {
	var instance = {};

	var $imageCaptionList;
	var $tableCaptionList;
	var $videoCaptionList;

	// captions in main blocks area
	instance.enumerateCaptions = function() {
		$imageCaptionList = $('.xblocks .js-image-caption-counter');
		$tableCaptionList = $('.xblocks .js-table-caption-counter');
		$videoCaptionList = $('.xblocks .js-video-caption-counter');

		$imageCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$tableCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$videoCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
	}

	// captions in presentation slider
	instance.enumeratePresentationCaptions = function() {
		$imageCaptionList = $('.presentation .js-image-caption-counter');
		$tableCaptionList = $('.presentation .js-table-caption-counter');
		$videoCaptionList = $('.presentation .js-video-caption-counter');

		$imageCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$tableCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
		$videoCaptionList.each(function(index) {
			$(this).html((index + 1) + '.');
		});
	}

	function construct() {
		instance.enumerateCaptions();
		instance.enumeratePresentationCaptions();
	}

	return {
		init: function() {
			construct();

			return instance;
		}
	};
})();
var nvsGlosarry = (function() {


  var instance = {};

  // public



  function construct() {


    if ($('.nvs-popper-window').length == 0) {
      $('body').append('<div class="nvs-popper-window"><button class="glossary__close js-nvs-popper-window-close" type="button"><span class="icon"><svg class="icon-close"><use xlink:href="#close"></use></svg></span></button><div class="popper__content"></div><div class="popper__arrow"></div></div>');
    }


    $('.js-nvs-popper-window-close').on('click', function() {
      popover.hide();
    });


    var reference = $('.nvs-tooltip');
    var popover = $('.nvs-popper-window');
    popover.hide();

    $(document).on('click touchend', function(e) {
      var target = $(e.target);
			
      // ne need to reshow and recreate poper when click over popup so return;
      if (target.is(popover)) return;

      if (target.is(reference)) {
        e.preventDefault();

        var html = '<div class="' + target.data('tooltip-class') + '"><h3>' + target.data('tooltip-term') + '</h3><div class="tooltip-body">' + target.data('tooltip-description');

        if (target.data('tooltip-link') !== '') {
          html += '<a href="' + target.data('tooltip-link') + '" class="glossary__link">' + window['pkc-locales'][document.documentElement.lang].glossary + '</a>';
        }

        html += '</div></div>';

        popover.children('.popper__content').html(html);
        popover.show();

        // notify analytics
        let anal = {
          block: target.attr('data-tooltip-id'),
          component: 'glossary-popup',
          verb: 'opened'
        };

        const ev = new CustomEvent('izzi:analytics', { detail: anal });
        window.dispatchEvent(ev);

        var popper = new Popper(target, popover, {
          placement: 'bottom'
        });

      }
      else {
        popover.hide();
      }

    });
  }

  return {
    init: function() {
      construct();

      return instance;
    }
  };
})();

var nvsIsApp = false;
var nvsIsMainNavButtonClicked = false;

var nvsMode = {
	
	mode: '', // bookshelf, app, preview

	init: function() {

		this.mode = 'bookshelf';

		if(
			location.protocol === 'file:'
			|| location.port === '8080'
		)
		{
			window.nvsIsApp == true;
			//this.preventMainNavButton();
			this.mode = 'app';
		}

		if(
			location.pathname.indexOf('preview') > -1
		)
		{
			this.mode = 'preview';
		}


	},

	getMode: function() {
		return this.mode;
	},

	preventMainNavButton: function() {

		$("#main-home").on('click', function(e){
			e.preventDefault();
			window.nvsIsMainNavButtonClicked = true;

			// setTimeout(function(){
			// 	window.nvsIsMainNavButtonClicked = false;
			// },3000);
		});
	}
};
// nvsSyncer

var nvsSyncer= (function() {
    
  var self = {};
    
  var onlineState = false;
    
  var bookshelfApi = window.dosData.bookshelfBase;
    
  // profil-klett has two domains. set proper api endpoint accordingly
  if (dosData.workspaceId === 10 && window.location.href.indexOf('moj.izzi.hr') > -1) {
    bookshelfApi = 'https://moj.izzi.hr/';
  }
    
    
  var dosId;
	
  var userId;
    
  var oldHash;

  var bearer = { key: 'lkasiasikaia7as67ashhjaua', value: 'lkjaslkasklakjsuujs76a7857as' };
    
  self.getItemsFromStorage = function (key) {
    return JSON.parse(localStorage.getItem(key)) ? JSON.parse(localStorage.getItem(key)) : false;
  };
    
  self.setItemsToStorage = function (key, data) {
    localStorage.setItem(key, JSON.stringify(data));
  };
    
  self.postApiSync = function(data) {

    self.storeHash();

    $('.sync-spinner').show();

    var queryStr = '?';
    if(nvsMode.getMode() == 'preview') {
      queryStr += bearer.key + '=' + bearer.value;
    }

    $.ajax({
      type: 'POST',
      url: bookshelfApi + 'api/sync' + queryStr,
      // The key needs to match your method's input parameter (case-sensitive).
      data: JSON.stringify(data),
      contentType: 'application/json; charset=utf-8',
      dataType: 'json',
      xhrFields: {
        withCredentials: true
      },
      success: function(res){
        console.log('postApiSync() SUCCESS:', res['data']);
        $('.sync-spinner').hide();
                
        if(self.hashMatch()) {
          self.updateStorageData(res['data']);
          $(document).trigger('nvsSyncer:synced');
        }
        else {
          self.syncStorageData();
        }             
      },
      error: function(errMsg) {
        console.log('postApiSync() ERROR:', errMsg);
        $('.sync-spinner').hide();
      }
    });
  };
    
  self.syncStorageData = function() {
    var bookmarkDataKey = 'DOS_BookmarkItems';
    var quizDataKey = 'DOS_QuizResults';
        
    var bookmarkData = self.getItemsFromStorage(bookmarkDataKey);
    var quizData = self.getItemsFromStorage(quizDataKey);
        
    var body = {
      bookmark: {},
      quiz: {}
    };
    console.log('syncStorage quizData', quizData);
        
    body['bookmark'] = bookmarkData[userId][dosId];
    body['bookmark']['uid'] = userId;
    body['bookmark']['dosId'] = dosId;
    body['quiz']['quizesList'] = quizData[userId][dosId];
    body['quiz']['uid'] = userId;
    body['quiz']['dosId'] = dosId;
        
    self.postApiSync(body);
  };
    
  self.storeHash = function() {
    var combinedString = self.getItemsFromStorage('DOS_BookmarkItems') + self.getItemsFromStorage('DOS_QuizResults');
    oldHash = combinedString.hashCode();
  };
    
  self.hashMatch = function() {
    var combinedString = self.getItemsFromStorage('DOS_BookmarkItems') + self.getItemsFromStorage('DOS_QuizResults');
    return oldHash == combinedString.hashCode();
  };
    
  self.updateStorageData = function(data) {
    if(data) {
      console.log('updateStorageData() data:', data);
      var bookmarkDataKey = 'DOS_BookmarkItems';
      var quizDataKey = 'DOS_QuizResults';
            
      var bookmarkData = self.getItemsFromStorage(bookmarkDataKey);
      var quizData = self.getItemsFromStorage(quizDataKey);
            
      bookmarkData[data['bookmark']['uid']][data['bookmark']['dosId']]['highlightList'] = data['bookmark']['highlightList'];
      bookmarkData[data['bookmark']['uid']][data['bookmark']['dosId']]['bookmarkList'] = data['bookmark']['bookmarkList'];

      var quizesList = data['quiz']['quizesList'].constructor == Array ? {} : data['quiz']['quizesList'];
      quizData[data['quiz']['uid']][data['quiz']['dosId']] = quizesList;
            
      self.setItemsToStorage(bookmarkDataKey, bookmarkData);
      self.setItemsToStorage(quizDataKey, quizData);
    }
  };
    
    
    
  self.fireEvent = function(name, data) {
    var e = document.createEvent('Event');
    e.initEvent(name, true, true);
    e.data = data;
    window.dispatchEvent(e);
  };
    
    
  self.watchNetwork = function () {
        
    Offline.check();

    setTimeout(() => {
        
      if(Offline.state == 'up') {
        self.fireEvent('goodconnection', {});
      }
      else if(Offline.state == 'down') {
        self.fireEvent('connectionerror', {});
      }
    }, 1500);
  };
    
  self.intervalTest = function (online) {
    if(onlineState != online && online) {
      console.log('online status changed: you are online!!!');
      self.syncStorageData();
    }
        
    onlineState = online;
  };
    
  self.appendSpinnerBox = function() {
    $('body').append('<div class="sync-spinner"></div>');
  };
    
  function getCookie(cname) {
    var name = cname + '=';
    var decodedCookie = decodeURIComponent(document.cookie);
    var ca = decodedCookie.split(';');
    for(var i = 0; i <ca.length; i++) {
      var c = ca[i];
      while (c.charAt(0) == ' ') {
        c = c.substring(1);
      }
      if (c.indexOf(name) == 0) {
        return c.substring(name.length, c.length);
      }
    }
    return '';
  }

  function bindEvents() {
    window.addEventListener('goodconnection', function(e) {
      // console.log("online");
      self.intervalTest(true);
    });
    window.addEventListener('connectionerror', function(e) {
      // console.log("offline");
      self.intervalTest(false);
    });
    window.addEventListener('connectiontimeout', function(e) {
      // console.log("connectiontimeout");
    });
  }
    
  function construct() {
        
    self.appendSpinnerBox();
        
    dosId = dosData['dosId'];
    // userId = localStorage.getItem('nvsUserId') ? localStorage.getItem('nvsUserId') : false;
        
    //temp
    // userId = localStorage.getItem('nvsUserId') ? localStorage.getItem('nvsUserId') : 'dummy_id';
    if(localStorage.getItem('devMode')) {
      bookshelfApi = window.location.hostname;
    }

    if(localStorage.getItem('nvsSyncerUrl')) {
      bookshelfApi = localStorage.getItem('nvsSyncerUrl');
    }

    Offline.options = {
      checks: {
        xhr: { url: bookshelfApi + 'favicon.ico' } // Always specify the server domain. Otherwise it would default to file://favicon.ico in downloaded publications.
      },
      checkOnLoad: true, // Automatically check network status on first load.
      interceptRequests: false, // Don't use every request to determine network status.
      reconnect: false, // Don't check automatically, we will set the interval manually.
      requests: false, // Don't queue all failed requests to re-attempt when the connection is established.
    };
        
    if(nvsMode.getMode() == 'preview') {
      localStorage.setItem('nvsUserId', -1);
    }

    if(localStorage.getItem('nvsUserId')) {
      userId = localStorage.getItem('nvsUserId');
    }
    else if(getCookie('user_id')) {
      userId = getCookie('user_id');
      localStorage.setItem('nvsUserId', userId);
    }
    else {
      userId = 'dummy_id';
      localStorage.setItem('nvsUserId', userId);
    }

    $(document).trigger('nvsSyncer:ready');

    var checkNetworkInterval = setInterval(function() {
      self.watchNetwork();
    }, 15000);
        
    bindEvents();
  }
    
  return {
    init: function() {
      construct();
            
      return self;
    }
  };
})();

$.fn.isOnScreen = function () {

  var win = $(window);

  var viewport = {
    top: win.scrollTop(),
    left: win.scrollLeft()
  };
  viewport.right = viewport.left + win.width();
  viewport.bottom = viewport.top + win.height();

  var bounds = this.offset();
  bounds.right = bounds.left + this.outerWidth();
  bounds.bottom = bounds.top + this.outerHeight();

  return (!(viewport.right < bounds.left || viewport.left > bounds.right || viewport.bottom < bounds.top || viewport.top > bounds.bottom));

};


// TODO: ovo je nesto na pojmovniku ja mislim

// var stickyPager = function () {
// 	// TODO: sto ovo treba raditi? sad ne radi nista!
// 	var footer = $('.site-footer').eq(0);
// 	if ((footer).lenght > 0) {
// 		if (footer.isOnScreen()) {
// 			$('.sticky-nav').addClass('notSticky');
// 		}
// 		else {
// 			$('.sticky-nav').removeClass('notSticky');
// 		}
// 	}

// };


var wordLengthCounter = function () {

  if ($('.hero-title').length) {
    var naslov = $('.hero-title');
    var str = $('.hero-title').html();
    var strSplit = str.split(' ');
    var longestWord = 0;
    for (var i = 0; i < strSplit.length; i++) {
      if (strSplit[i].length > longestWord) {
        longestWord = strSplit[i].length;
      }
    }
    if (longestWord >= 9) {
      $(naslov).addClass('hero-title--shrinked');
    }
    return longestWord;
  }
};

// echo in console
var nvsDebug = false;

var nvsSyncerInstance = false;

//hashCode

String.prototype.hashCode = function() {
  var hash = 0, i, chr;
  if (this.length === 0) return hash;
  for (i = 0; i < this.length; i++) {
    chr   = this.charCodeAt(i);
    hash  = ((hash << 5) - hash) + chr;
    hash |= 0; // Convert to 32bit integerve
  }
  return hash;
};



//\\//\\//\\//\\//\\//
//\\Document ready\\//
//\\//\\//\\//\\//\\//
jQuery(document).ready(function () {

  // mobile app send sid to DOS through localStorage
  if(localStorage.getItem('nvsSid')) {
    document.cookie = 'PHPSESSID='+localStorage.getItem('nvsSid')+'; expires=31 Dec 2030 23:59:59 UTC; path=/';
  }

  // try to setup app mode
  nvsMode.init();

  nvsSecurity().init();

  wordLengthCounter();
	
}); //end document ready



//\\//\\//\\//\\//\\//
//\\Document load \\//
//\\//\\//\\//\\//\\//




//detect touch
window.addEventListener('touchstart', function onFirstTouch() {

  // we could use a class
  document.body.classList.add('touchstart', 'has-touch');

  // or set some global variable
  window.USER_IS_TOUCHING = true;

  // we only need to know once that a human touched the screen, so we can stop listening now
  window.removeEventListener('touchstart', onFirstTouch, false);
}, false);


$(document).ready(function () {
	var player = document.getElementById('global-audio-player');
	var handlePlayer = () => {
		$('.cta-audio--playing').removeClass('cta-audio--playing')
	}
	
	player.addEventListener('ended', handlePlayer)
	player.addEventListener('pause', handlePlayer)
})

$(document).on("click", "button[data-source]", function (event) {

	event.preventDefault();
	var source = $(this).attr('data-source');
	var player = document.getElementById('global-audio-player');

	/**
	* Čistimo iz razloga jer exportani DOS ima ./datastore, a live verzija ima /datastore
	* iz toga razloga na exportanom DOS-u bi nam uvijek ulazilo u treci uvijet, odnosno "else" jer nikad
	* ne bi zadovoljio uvijet player.src.includes(source) i onda ne bi mogli pauzirati nego non stop bi audio krenuo
	* ispocetka.
	*/

	var exportedDotClearForCompare = source;
	if (dosData.isExport == true) {// samo u slučaju exporta želimo preskociti prvi znak, tocku
		exportedDotClearForCompare = source.substring(1);
	}

	if (player.duration > 0 && !player.paused && player.src.indexOf(exportedDotClearForCompare) > -1) {
		// svira, a kliknuo si, znaci stopiraj
		player.pause();
		$('button.cta-audio').removeClass('cta-audio--playing');
	}
	else if (player.duration > 0 && player.paused && player.src.indexOf(exportedDotClearForCompare) > -1) {
		// svirao, a kliknuo si, znaci pokreni opet
		player.play();
		$('button.cta-audio').removeClass('cta-audio--playing');
		$(this).addClass('cta-audio--playing');
	}
	else {
		player.src = source; // postavlja se source ali se usporedbe rade s 'exportedDotClearForCompare'
		player.play();
		$('button.cta-audio').removeClass('cta-audio--playing');
		$(this).addClass('cta-audio--playing');
	}
});
